# Roadmap

The roadmap is a living document, and it is likely that priorities will change, but the list below should give some indication of our plans for the next major release, and for the future.

Please feel free to file issues on this repository if you have questions, concerns, or suggestions.

## Nelson 1.0

_Features_:

- String array type (DONE v0.2.10),
- Foreign Function Interface (DONE v0.2.4),
- Audio module (read, play DONE v0.2.1),
- JSON File I/O module (DONE v0.2.1),
- Inter-process communication between Nelson's process (DONE v0.4.9),
- MPI interface module (DONE v0.1.11),
- editor (DONE v0.1.11),
- SLICOT module: low level function about Controls (DONE v0.1.10),
- fftw module (DONE v0.1.8),
- COM objects (DONE v0.1.7),
- linear algebra module,
- Computer Aided Control Systems Design module,
- HDF5 high-level functions I/O (DONE v0.2.12),
- MAT File I/O module (DONE v0.3.3),
- HDF5 used as default data file format (.nh5) (DONE v0.3.2),
- Profiling and Coverage Tools for Nelson's language (DONE v0.3.4),
- Mex module (Done v0.4.7),
- Nelson Engine API for C (compatible with MEX Engine) (DONE v0.4.11),
- completion,
- graphics output (Graphic objects introduced in v0.4.5),
- some basic openCV functions,
- dynamic link functions (Nelson external modules) (DONE v0.2.6),
- Nelson on cloud (DONE v0.2.11),
- RESTful API web service (DONE v0.3.9).

## How can I help ?

Short term objectives are listed above. Our goal is to split down the workload in such way that anybody can jump in and help.
Please comment on issues if you want to take it to avoid duplicating effort!
Similarly, if a maintainer is already assigned on an issue you'd like to participate in, pinging him on GitHub to offer your help is
the best way to go.

## How can I add something to the roadmap ?

The roadmap process is new to Nelson: we are only beginning to structure and document the project objectives.
Our immediate goal is to be more transparent, and work with our community to
focus our efforts on fewer prioritized topics.
