%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
if ~isbuiltin('mxIsInteger')
    test_dir = [tempdir(), 'mxIsInteger'];
    if isdir(test_dir)
        rmdir(test_dir,'s');
    end
    mkdir(test_dir);
    status = copyfile('mxIsInteger.c', test_dir);
    assert_istrue(status);
    cd(test_dir);
    mex('mxIsInteger.c');
    run('loader.m');
end
%=============================================================================
assert_isequal(mxIsInteger(int8(3)), 'int8');
assert_isequal(mxIsInteger(int16(3)), 'int16');
assert_isequal(mxIsInteger(int32(3)), 'int32');
assert_isequal(mxIsInteger(int64(3)), 'int64');
%=============================================================================
assert_isequal(mxIsInteger(uint8(3)), 'uint8');
assert_isequal(mxIsInteger(uint16(3)), 'uint16');
assert_isequal(mxIsInteger(uint32(3)), 'uint32');
assert_isequal(mxIsInteger(uint64(3)), 'uint64');
%=============================================================================
assert_isequal(mxIsInteger(true), 'not integer');
%=============================================================================
